package com.jh.boot;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Bean;

import com.jh.boot.email.LocalEmailService;
import com.jh.boot.security.utils.TemplateEmailAuthServiceListener;

public class JhBootApplication {

	@Bean
    @ConditionalOnProperty(value = "email.local.enabled", havingValue = "true", matchIfMissing = true)
	public LocalEmailService emailService() {
		return new LocalEmailService();
	}

	
    @Bean
    @ConditionalOnProperty(value = "security.auth.listener.email.enabled", havingValue = "true", matchIfMissing = true)
    public TemplateEmailAuthServiceListener authServiceListener() {
    	return new TemplateEmailAuthServiceListener();
    }
    
    

}
