package com.jh.boot.security.utils;

import java.io.StringWriter;
import java.util.Collections;
import java.util.Locale;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import com.jh.boot.email.Email;
import com.jh.boot.email.EmailService;
import com.jh.boot.security.AuthServiceListener;
import com.jh.boot.security.model.AppUser;
import com.jh.boot.template.TemplateService;


//TODO make it configurable
public class TemplateEmailAuthServiceListener implements AuthServiceListener {

	@Autowired
	private EmailService emailService;
	
	@Autowired
	private TemplateService templateService;
	
	@Value("${security.auth.template.signup:security.auth.signup}")
	private String signupTemplateCode;

	@Value("${security.auth.template.signup.html:security.auth.signup.html}")
	private String signupTemplateHtmlCode;

	@Value("${security.auth.template.resetPassword:security.auth.resetPassword}")
	private String resetPasswordTemplateCode;
	
	
	@Override
	public void registerUser(AppUser user) {
		StringWriter sw = new StringWriter();
		templateService.evaluate(sw, signupTemplateCode, Collections.singletonMap("user", user), Locale.ENGLISH);
		
		Email email = new Email();
		email.setText(sw.toString());
		emailService.sendEmail(email);
	}

	
	@Override
	public void generateResetToken(AppUser user) {
		StringWriter sw = new StringWriter();
		templateService.evaluate(sw, resetPasswordTemplateCode, Collections.singletonMap("user", user), Locale.ENGLISH);
	}

}
