package com.jh.boot.template.customizable;

import java.io.Writer;
import java.util.Collections;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;

import com.jh.boot.template.TemplateEngine;
import com.jh.boot.template.TemplateService;

public class CustomizableTemplateService implements TemplateService {

	@Autowired
	private TemplateEngine engine;
	
	@Autowired
	private CustomizableLabelsService labelsService;
	
	
	@Override
	public void evaluate(Writer writer, String templateCode, Map<String, Object> data, Locale locale) {
		if (data == null) {
			data = Collections.emptyMap();
		}
		
		Map<String, String> labels = labelsService.getTranslatedTemplateLabels(templateCode, null, locale.toString());

		data = new HashMap<String, Object>(data);
		data.put("labels", locale);
		engine.evaluate(writer, templateCode, data);
	}
	
}
